package com.diagbot.facade;

import com.diagbot.dto.BillDTO;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.WordBillCrfDTO;
import com.diagbot.vo.BillNeoVO;
import com.diagbot.vo.IndicationPushVO;
import com.diagbot.vo.StandConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.diagbot.biz.push.entity.Item;

import java.util.List;

import java.util.Map;

/**
 * @Description: 开单合理性facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class BillFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    RuleFacade ruleFacade;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 开单合理性业务
     * @param
     * @return
     */
    public BillDTO billFac(IndicationPushVO indicationPushVO) {
        // 模型处理数据 TODO
        WordBillCrfDTO wordBillCrfDTO = commonFacade.crf_process(indicationPushVO);
        StandConvert standConvert = commonFacade.dataTypeGet(wordBillCrfDTO);

        // 标准词转换 TODO
        Map<String, Map<String, String>> typeStand = neoFacade.standConvert(standConvert);
        wordBillCrfDTO = commonFacade.dataTypeSet(wordBillCrfDTO, typeStand);

        // 图谱接口调用
        BillNeoVO billNeoVO = fillBillNeo(indicationPushVO);

        BillNeoDTO billNeoDTO = neoFacade.getBillNeo(billNeoVO);

        // 规则开发 TODO
        neoFacade.getDrugCache();
        return null;
    }


    public BillNeoVO fillBillNeo(IndicationPushVO indicationPushVO) {
        BillNeoVO billNeoVO = new BillNeoVO();

        List<Item> items = indicationPushVO.getDrug();
        for (Item item : items) {
            billNeoVO.getDrugList().add(item.getName());
        }

        return billNeoVO;
    }
}
